from ollama_x_client import AuthenticatedClient

# ollama-x-client

This is the autogenerated client for the Ollama-X project. Ollama-X is a backend application that 
allows to balance the load of Ollama instances and control users' access to them.

## Installation

Using pip:

```sh
pip install ollama-x-client
```

Using poetry:

```sh
poetry add ollama-x-client
```

## Usage

```python
from ollama_x_client.client import AuthenticatedClient
from ollama_x_client.api.user.create import sync_detailed as create_user
from ollama_x_client.models import CreateUserRequest

client = AuthenticatedClient(base_url="http://localhost:8000")

response = create_user(
    client=client,
    body=CreateUserRequest("test-user")
)
```

## How to generate

To generate the client, you need to have the OpenAPI specification file. You can download it from the Ollama-X server by visiting the `/openapi.json` endpoint.

Then, you can generate the client using the OpenAPI CLI:

```sh
openapi-cli generate --url https://<ollama_x_instance>/openapi.json --output ollama_x_client 
--no-install --no-interaction
```

This will generate the client in the `ollama_x_client` directory.
